#property show_inputs

#include <stdlib.mqh>

extern double General_Profit = 1000.0;
string g_name_84 = "     ";
int g_slippage_92 = 0;

int deinit() {
   ObjectDelete(g_name_84);
   return (0);
}

int start() {
   if (ObjectFind(g_name_84) == -1) {
      ObjectCreate(g_name_84, OBJ_LABEL, 0, 0, 0);
      ObjectSet(g_name_84, OBJPROP_XDISTANCE, 5);
      ObjectSet(g_name_84, OBJPROP_YDISTANCE, 20);
      ObjectSet(g_name_84, OBJPROP_COLOR, PaleGreen);
      ObjectSetText(g_name_84, "     ", 8, "Arial", PaleGreen);
   }
   for (int l_ord_total_0 = OrdersTotal(); l_ord_total_0 > 0; l_ord_total_0 = OrdersTotal()) {
      CloseAllByGeneralProfit();
      Sleep(1000);
   }
   return (0);
}

void CloseAllByGeneralProfit() {
   int l_error_16;
   double ld_0 = 0;
   int l_ord_total_8 = OrdersTotal();
   if (l_ord_total_8 > 0) {
      for (int l_pos_12 = l_ord_total_8 - 1; l_pos_12 >= 0; l_pos_12--) {
         if (OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES)) ld_0 += OrderProfit() + OrderSwap();
         else {
            l_error_16 = GetLastError();
            Print("    :" + ErrorDescription(l_error_16));
         }
      }
   }
   if (ld_0 >= General_Profit) CloseAll();
}

void CloseAll() {
   CloseAllSell();
   CloseAllBuy();
}

void CloseAllSell() {
   int l_datetime_12;
   int l_error_16;
   int l_ord_total_4 = OrdersTotal();
   if (l_ord_total_4 > 0) {
      for (int l_pos_0 = l_ord_total_4 - 1; l_pos_0 >= 0; l_pos_0--) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderType() == OP_SELL) {
               while (IsTradeContextBusy()) Sleep(1000);
               l_datetime_12 = TimeCurrent();
               RefreshRates();
               for (int l_ord_close_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), g_slippage_92, Yellow); !l_ord_close_8 && TimeCurrent() - l_datetime_12 <= 120 &&
                  !IsTesting(); l_ord_close_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), g_slippage_92, Yellow)) {
                  Sleep(1000);
                  while (IsTradeContextBusy()) Sleep(500);
                  RefreshRates();
               }
               if (!l_ord_close_8) {
                  l_error_16 = GetLastError();
                  Print("   SELL #" + OrderTicket() + " " + ErrorDescription(l_error_16));
               }
            }
         } else Print("    :" + ErrorDescription(l_error_16));
      }
   }
}

void CloseAllBuy() {
   int l_datetime_12;
   int l_error_16;
   int l_ord_total_4 = OrdersTotal();
   if (l_ord_total_4 > 0) {
      for (int l_pos_0 = l_ord_total_4 - 1; l_pos_0 >= 0; l_pos_0--) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderType() == OP_BUY) {
               while (IsTradeContextBusy()) Sleep(1000);
               l_datetime_12 = TimeCurrent();
               RefreshRates();
               for (int l_ord_close_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), g_slippage_92, Yellow); !l_ord_close_8 && TimeCurrent() - l_datetime_12 <= 120 &&
                  !IsTesting(); l_ord_close_8 = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), g_slippage_92, Yellow)) {
                  Sleep(1000);
                  while (IsTradeContextBusy()) Sleep(1000);
                  RefreshRates();
               }
               if (!l_ord_close_8) {
                  l_error_16 = GetLastError();
                  Print("   BUY #" + OrderTicket() + " " + ErrorDescription(l_error_16));
               }
            }
         } else Print("    :" + ErrorDescription(l_error_16));
      }
   }
}